<?php

/**
 *  Sandbox Authorize
dediteam69 / Ded1@gency

API LOGIN ID : 2PnJWh4S9D6k
TRANSACTION KEY : 5H49H8PB8rB68wyc
SECRET KEY : Simon
 */

namespace Bydedi\Payment;

use AuthorizeNetAIM;
use Tpe;
use Commande;
use Panier;

/**
 * Class AuthorizeDirect
 * @package Shopbydedi\Payment
 */
class AuthorizeDirect
{
    /**
     * @var string
     */
    protected $mode;

    public function __construct($config)
    {
        if ($config['authorize']['mode'] != 'prod') {
            define("AUTHORIZENET_SANDBOX", true);
            $config['authorize']['name'] = '2PnJWh4S9D6k';
            $config['authorize']['transaction_key'] = '5H49H8PB8rB68wyc';
        }

        define("AUTHORIZENET_API_LOGIN_ID", $config['authorize']['name']);
        define("AUTHORIZENET_TRANSACTION_KEY", $config['authorize']['transaction_key']);
    }

    /**
     * @param Tpe $tpe
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     *
     * @return mixed
     */
    public function doAuthorization(Tpe $tpe, $amount, $cardNumber, $cardExpirationDate, $cardCrypto)
    {
        // TODO: Implement doAuthorization() method.
    }

    /**
     * @param Tpe $tpe
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     *
     * @return mixed
     */
    public function doDebit(Tpe $tpe, $amount, $cardNumber, $cardExpirationDate, $cardCrypto)
    {

        $sale           = new AuthorizeNetAIM;
        $sale->amount   = $amount;
        $sale->card_num = $cardNumber;
        $sale->exp_date = $cardExpirationDate;
        $response = (array) $sale->authorizeAndCapture();

        unset($response['AuthorizeNetAIM_Response_response_array']);

        $response['order_id'] = $tpe->tpe_reference_id;

        return $this->response($response);

    }

    /**
     * @param array $request
     *
     * @return mixed
     */
    public function response($request)
    {
        $return = ['status' => false];

        if (!empty($request['order_id'])) {
            $tpe = new Tpe;

            // cas response ok
            if ($request['approved'] == true) {

                $commande = new Commande();
                try {
                    $return['commande_id'] = $commande->saveFromPanier(Panier::getInstance());
                    $tpe->assoc($request['order_id'], $return['commande_id']);
                } catch (\Exception $e) {
                    $return['status'] = false;
                    $return['tpe_reference_id'] = $request['order_id'];
                    return $return;
                }

                $return['status'] = true;
                $return['tpe_reference_id'] = $request['order_id'];
            } else {
                $return = array_merge($return, $request);
            }

            $tpe->addResponse($request['order_id'], $request);
        }

        return $return;
    }

    /**
     * @param $params
     * @return mixed
     */
    public function sendRequest($params)
    {
        // TODO: Implement sendRequest() method.
    }
}
